package com.pact;

import java.io.*;
import java.util.HashSet;

public class Main {

    public HashSet<Node> process(String in)
            throws IOException, BracketException {
        BufferedReader inB = new BufferedReader(new FileReader(in));
        String line;
        HashSet<Node> templates = null;

        // Read in trees one at a time
        while((line = inB.readLine()) != null){
            if(templates == null) {
                // Load first line into template
                templates = new HashSet<>();
                templates.add(new Node(null, line));
                continue;
            }

            HashSet<Node> allCombined = new HashSet<>();

            Node input = new Node(null, line);
            for (Node template : templates) {
                // Get all the ways we can combine input with template
                HashSet<Node> combined = Node.reducedCombine(template, input);
                System.out.println("com: " + combined);
                allCombined.addAll(combined);
            }
            templates = allCombined;
        }
        inB.close();
        return templates;
    }

    public static void main(String[] args) {
        Main main = new Main();
        String inputFilename = "input.txt";
        HashSet<Node> result;
        try {
            result = main.process(inputFilename);
            System.out.println("----------------------------------------");
            System.out.println("----------------------------------------");

            for(Node node : result){
                System.out.println(node.getVenn());
            }
        } catch (IOException e){
            System.out.println("Status: Fail, write error\n" + e);
        }
    }

}
